Loading...
1# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
4
5PHONY += oldconfig xconfig gconfig menuconfig config silentoldconfig update-po-config \
6 localmodconfig localyesconfig
7
8ifdef KBUILD_KCONFIG
9Kconfig := $(KBUILD_KCONFIG)
10else
11Kconfig := Kconfig
12endif
13
14# We need this, in case the user has it in its environment
15unexport CONFIG_
16
17xconfig: $(obj)/qconf
18 $< $(Kconfig)
19
20gconfig: $(obj)/gconf
21 $< $(Kconfig)
22
23menuconfig: $(obj)/mconf
24 $< $(Kconfig)
25
26config: $(obj)/conf
27 $< --oldaskconfig $(Kconfig)
28
29nconfig: $(obj)/nconf
30 $< $(Kconfig)
31
32oldconfig: $(obj)/conf
33 $< --$@ $(Kconfig)
34
35silentoldconfig: $(obj)/conf
36 $(Q)mkdir -p include/generated
37 $< --$@ $(Kconfig)
38
39localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
40 $(Q)mkdir -p include/generated
41 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
42 $(Q)if [ -f .config ]; then \
43 cmp -s .tmp.config .config || \
44 (mv -f .config .config.old.1; \
45 mv -f .tmp.config .config; \
46 $(obj)/conf --silentoldconfig $(Kconfig); \
47 mv -f .config.old.1 .config.old) \
48 else \
49 mv -f .tmp.config .config; \
50 $(obj)/conf --silentoldconfig $(Kconfig); \
51 fi
52 $(Q)rm -f .tmp.config
53
54# Create new linux.pot file
55# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
56update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
57 $(Q)echo " GEN config.pot"
58 $(Q)xgettext --default-domain=linux \
59 --add-comments --keyword=_ --keyword=N_ \
60 --from-code=UTF-8 \
61 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
62 --directory=$(srctree) --directory=$(objtree) \
63 --output $(obj)/config.pot
64 $(Q)sed -i s/CHARSET/UTF-8 $(obj)/config.pot
65 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
66 $(srctree)/arch/*/um/Kconfig`; \
67 do \
68 echo " GEN $$i"; \
69 $(obj)/kxgettext $$i \
70 >> $(obj)/config.pot; \
71 done )
72 $(Q)echo " GEN linux.pot"
73 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
74 --output $(obj)/linux.pot
75 $(Q)rm -f $(obj)/config.pot
76
77PHONY += allnoconfig allyesconfig allmodconfig alldefconfig randconfig
78
79allnoconfig allyesconfig allmodconfig alldefconfig randconfig: $(obj)/conf
80 $< --$@ $(Kconfig)
81
82PHONY += listnewconfig olddefconfig oldnoconfig savedefconfig defconfig
83
84listnewconfig olddefconfig: $(obj)/conf
85 $< --$@ $(Kconfig)
86
87# oldnoconfig is an alias of olddefconfig, because people already are dependent
88# on its behavior(sets new symbols to their default value but not 'n') with the
89# counter-intuitive name.
90oldnoconfig: $(obj)/conf
91 $< --olddefconfig $(Kconfig)
92
93savedefconfig: $(obj)/conf
94 $< --$@=defconfig $(Kconfig)
95
96defconfig: $(obj)/conf
97ifeq ($(KBUILD_DEFCONFIG),)
98 $< --defconfig $(Kconfig)
99else
100 @echo "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
101 $(Q)$< --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
102endif
103
104%_defconfig: $(obj)/conf
105 $(Q)$< --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
106
107# Help text used by make help
108help:
109 @echo ' config - Update current config utilising a line-oriented program'
110 @echo ' nconfig - Update current config utilising a ncurses menu based program'
111 @echo ' menuconfig - Update current config utilising a menu based program'
112 @echo ' xconfig - Update current config utilising a QT based front-end'
113 @echo ' gconfig - Update current config utilising a GTK based front-end'
114 @echo ' oldconfig - Update current config utilising a provided .config as base'
115 @echo ' localmodconfig - Update current config disabling modules not loaded'
116 @echo ' localyesconfig - Update current config converting local mods to core'
117 @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
118 @echo ' defconfig - New config with default from ARCH supplied defconfig'
119 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
120 @echo ' allnoconfig - New config where all options are answered with no'
121 @echo ' allyesconfig - New config where all options are accepted with yes'
122 @echo ' allmodconfig - New config selecting modules when possible'
123 @echo ' alldefconfig - New config with all symbols set to default'
124 @echo ' randconfig - New config with random answer to all options'
125 @echo ' listnewconfig - List new options'
126 @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their default value'
127
128# lxdialog stuff
129check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
130
131# Use recursively expanded variables so we do not call gcc unless
132# we really need to do so. (Do not call gcc as part of make mrproper)
133HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
134 -DLOCALE
135
136# ===========================================================================
137# Shared Makefile for the various kconfig executables:
138# conf: Used for defconfig, oldconfig and related targets
139# nconf: Used for the nconfig target.
140# Utilizes ncurses
141# mconf: Used for the menuconfig target
142# Utilizes the lxdialog package
143# qconf: Used for the xconfig target
144# Based on QT which needs to be installed to compile it
145# gconf: Used for the gconfig target
146# Based on GTK which needs to be installed to compile it
147# object files used by all kconfig flavours
148
149lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
150lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
151
152conf-objs := conf.o zconf.tab.o
153mconf-objs := mconf.o zconf.tab.o $(lxdialog)
154nconf-objs := nconf.o zconf.tab.o nconf.gui.o
155kxgettext-objs := kxgettext.o zconf.tab.o
156qconf-cxxobjs := qconf.o
157qconf-objs := zconf.tab.o
158gconf-objs := gconf.o zconf.tab.o
159
160hostprogs-y := conf
161
162ifeq ($(MAKECMDGOALS),nconfig)
163 hostprogs-y += nconf
164endif
165
166ifeq ($(MAKECMDGOALS),menuconfig)
167 hostprogs-y += mconf
168endif
169
170ifeq ($(MAKECMDGOALS),update-po-config)
171 hostprogs-y += kxgettext
172endif
173
174ifeq ($(MAKECMDGOALS),xconfig)
175 qconf-target := 1
176endif
177ifeq ($(MAKECMDGOALS),gconfig)
178 gconf-target := 1
179endif
180
181
182ifeq ($(qconf-target),1)
183 hostprogs-y += qconf
184endif
185
186ifeq ($(gconf-target),1)
187 hostprogs-y += gconf
188endif
189
190clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
191clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
192clean-files += mconf qconf gconf nconf
193clean-files += config.pot linux.pot
194
195# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
196PHONY += $(obj)/dochecklxdialog
197$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
198$(obj)/dochecklxdialog:
199 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
200
201always := dochecklxdialog
202
203# Add environment specific flags
204HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
205
206# generated files seem to need this to find local include files
207HOSTCFLAGS_zconf.lex.o := -I$(src)
208HOSTCFLAGS_zconf.tab.o := -I$(src)
209
210LEX_PREFIX_zconf := zconf
211YACC_PREFIX_zconf := zconf
212
213HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
214HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
215
216HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
217HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
218 -Wno-missing-prototypes
219
220HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
221
222HOSTLOADLIBES_nconf = $(shell \
223 pkg-config --libs menu panel ncurses 2>/dev/null \
224 || echo "-lmenu -lpanel -lncurses" )
225$(obj)/qconf.o: $(obj)/.tmp_qtcheck
226
227ifeq ($(qconf-target),1)
228$(obj)/.tmp_qtcheck: $(src)/Makefile
229-include $(obj)/.tmp_qtcheck
230
231# QT needs some extra effort...
232$(obj)/.tmp_qtcheck:
233 @set -e; echo " CHECK qt"; dir=""; pkg=""; \
234 if ! pkg-config --exists QtCore 2> /dev/null; then \
235 echo "* Unable to find the QT4 tool qmake. Trying to use QT3"; \
236 pkg-config --exists qt 2> /dev/null && pkg=qt; \
237 pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
238 if [ -n "$$pkg" ]; then \
239 cflags="\$$(shell pkg-config $$pkg --cflags)"; \
240 libs="\$$(shell pkg-config $$pkg --libs)"; \
241 moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
242 dir="$$(pkg-config $$pkg --variable=prefix)"; \
243 else \
244 for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
245 if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
246 done; \
247 if [ -z "$$dir" ]; then \
248 echo >&2 "*"; \
249 echo >&2 "* Unable to find any QT installation. Please make sure that"; \
250 echo >&2 "* the QT4 or QT3 development package is correctly installed and"; \
251 echo >&2 "* either qmake can be found or install pkg-config or set"; \
252 echo >&2 "* the QTDIR environment variable to the correct location."; \
253 echo >&2 "*"; \
254 false; \
255 fi; \
256 libpath=$$dir/lib; lib=qt; osdir=""; \
257 $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
258 osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
259 test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
260 test -f $$libpath/libqt-mt.so && lib=qt-mt; \
261 cflags="-I$$dir/include"; \
262 libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
263 moc="$$dir/bin/moc"; \
264 fi; \
265 if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
266 echo "*"; \
267 echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
268 echo "*"; \
269 moc="/usr/bin/moc"; \
270 fi; \
271 else \
272 cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \
273 libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \
274 moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \
275 [ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \
276 fi; \
277 echo "KC_QT_CFLAGS=$$cflags" > $@; \
278 echo "KC_QT_LIBS=$$libs" >> $@; \
279 echo "KC_QT_MOC=$$moc" >> $@
280endif
281
282$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
283
284ifeq ($(gconf-target),1)
285-include $(obj)/.tmp_gtkcheck
286
287# GTK needs some extra effort, too...
288$(obj)/.tmp_gtkcheck:
289 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
290 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
291 touch $@; \
292 else \
293 echo >&2 "*"; \
294 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
295 echo >&2 "*"; \
296 false; \
297 fi \
298 else \
299 echo >&2 "*"; \
300 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
301 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
302 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
303 echo >&2 "*"; \
304 false; \
305 fi
306endif
307
308$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
309
310$(obj)/qconf.o: $(obj)/qconf.moc
311
312quiet_cmd_moc = MOC $@
313 cmd_moc = $(KC_QT_MOC) -i $< -o $@
314
315$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
316 $(call cmd,moc)
317
318# Extract gconf menu items for I18N support
319$(obj)/gconf.glade.h: $(obj)/gconf.glade
320 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
321 $(obj)/gconf.glade
322
1# SPDX-License-Identifier: GPL-2.0
2# ===========================================================================
3# Kernel configuration targets
4# These targets are used from top-level makefile
5
6ifdef KBUILD_KCONFIG
7Kconfig := $(KBUILD_KCONFIG)
8else
9Kconfig := Kconfig
10endif
11
12ifndef KBUILD_DEFCONFIG
13KBUILD_DEFCONFIG := defconfig
14endif
15
16ifeq ($(quiet),silent_)
17silent := -s
18endif
19
20export KCONFIG_DEFCONFIG_LIST :=
21ifndef cross_compiling
22kernel-release := $(shell uname -r)
23KCONFIG_DEFCONFIG_LIST += \
24 /lib/modules/$(kernel-release)/.config \
25 /etc/kernel-config \
26 /boot/config-$(kernel-release)
27endif
28KCONFIG_DEFCONFIG_LIST += arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)
29
30# We need this, in case the user has it in its environment
31unexport CONFIG_
32
33config-prog := conf
34menuconfig-prog := mconf
35nconfig-prog := nconf
36gconfig-prog := gconf
37xconfig-prog := qconf
38
39define config_rule
40PHONY += $(1)
41$(1): $(obj)/$($(1)-prog)
42 $(Q)$$< $(silent) $(Kconfig)
43
44PHONY += build_$(1)
45build_$(1): $(obj)/$($(1)-prog)
46endef
47
48$(foreach c, config menuconfig nconfig gconfig xconfig, $(eval $(call config_rule,$(c))))
49
50PHONY += localmodconfig localyesconfig
51localyesconfig localmodconfig: $(obj)/conf
52 $(Q)$(PERL) $(srctree)/$(src)/streamline_config.pl --$@ $(srctree) $(Kconfig) > .tmp.config
53 $(Q)if [ -f .config ]; then \
54 cmp -s .tmp.config .config || \
55 (mv -f .config .config.old.1; \
56 mv -f .tmp.config .config; \
57 $< $(silent) --oldconfig $(Kconfig); \
58 mv -f .config.old.1 .config.old) \
59 else \
60 mv -f .tmp.config .config; \
61 $< $(silent) --oldconfig $(Kconfig); \
62 fi
63 $(Q)rm -f .tmp.config
64
65# These targets map 1:1 to the commandline options of 'conf'
66#
67# Note:
68# syncconfig has become an internal implementation detail and is now
69# deprecated for external use
70simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
71 alldefconfig randconfig listnewconfig olddefconfig syncconfig \
72 helpnewconfig yes2modconfig mod2yesconfig mod2noconfig
73
74PHONY += $(simple-targets)
75
76$(simple-targets): $(obj)/conf
77 $(Q)$< $(silent) --$@ $(Kconfig)
78
79PHONY += savedefconfig defconfig
80
81savedefconfig: $(obj)/conf
82 $(Q)$< $(silent) --$@=defconfig $(Kconfig)
83
84defconfig: $(obj)/conf
85ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
86 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
87 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
88else
89 @$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
90 $(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
91endif
92
93%_defconfig: $(obj)/conf
94 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
95
96configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
97
98%.config: $(obj)/conf
99 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
100 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
101 $(Q)$(MAKE) -f $(srctree)/Makefile olddefconfig
102
103PHONY += tinyconfig
104tinyconfig:
105 $(Q)KCONFIG_ALLCONFIG=kernel/configs/tiny-base.config $(MAKE) -f $(srctree)/Makefile allnoconfig
106 $(Q)$(MAKE) -f $(srctree)/Makefile tiny.config
107
108# CHECK: -o cache_dir=<path> working?
109PHONY += testconfig
110testconfig: $(obj)/conf
111 $(Q)$(PYTHON3) -B -m pytest $(srctree)/$(src)/tests \
112 -o cache_dir=$(abspath $(obj)/tests/.cache) \
113 $(if $(findstring 1,$(KBUILD_VERBOSE)),--capture=no)
114clean-files += tests/.cache
115
116# Help text used by make help
117help:
118 @echo ' config - Update current config utilising a line-oriented program'
119 @echo ' nconfig - Update current config utilising a ncurses menu based program'
120 @echo ' menuconfig - Update current config utilising a menu based program'
121 @echo ' xconfig - Update current config utilising a Qt based front-end'
122 @echo ' gconfig - Update current config utilising a GTK+ based front-end'
123 @echo ' oldconfig - Update current config utilising a provided .config as base'
124 @echo ' localmodconfig - Update current config disabling modules not loaded'
125 @echo ' except those preserved by LMC_KEEP environment variable'
126 @echo ' localyesconfig - Update current config converting local mods to core'
127 @echo ' except those preserved by LMC_KEEP environment variable'
128 @echo ' defconfig - New config with default from ARCH supplied defconfig'
129 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
130 @echo ' allnoconfig - New config where all options are answered with no'
131 @echo ' allyesconfig - New config where all options are accepted with yes'
132 @echo ' allmodconfig - New config selecting modules when possible'
133 @echo ' alldefconfig - New config with all symbols set to default'
134 @echo ' randconfig - New config with random answer to all options'
135 @echo ' yes2modconfig - Change answers from yes to mod if possible'
136 @echo ' mod2yesconfig - Change answers from mod to yes if possible'
137 @echo ' mod2noconfig - Change answers from mod to no if possible'
138 @echo ' listnewconfig - List new options'
139 @echo ' helpnewconfig - List new options and help text'
140 @echo ' olddefconfig - Same as oldconfig but sets new symbols to their'
141 @echo ' default value without prompting'
142 @echo ' tinyconfig - Configure the tiniest possible kernel'
143 @echo ' testconfig - Run Kconfig unit tests (requires python3 and pytest)'
144
145# ===========================================================================
146# object files used by all kconfig flavours
147common-objs := confdata.o expr.o lexer.lex.o menu.o parser.tab.o \
148 preprocess.o symbol.o util.o
149
150$(obj)/lexer.lex.o: $(obj)/parser.tab.h
151HOSTCFLAGS_lexer.lex.o := -I $(srctree)/$(src)
152HOSTCFLAGS_parser.tab.o := -I $(srctree)/$(src)
153
154# conf: Used for defconfig, oldconfig and related targets
155hostprogs += conf
156conf-objs := conf.o $(common-objs)
157
158# nconf: Used for the nconfig target based on ncurses
159hostprogs += nconf
160nconf-objs := nconf.o nconf.gui.o $(common-objs)
161
162HOSTLDLIBS_nconf = $(call read-file, $(obj)/nconf-libs)
163HOSTCFLAGS_nconf.o = $(call read-file, $(obj)/nconf-cflags)
164HOSTCFLAGS_nconf.gui.o = $(call read-file, $(obj)/nconf-cflags)
165
166$(obj)/nconf: | $(obj)/nconf-libs
167$(obj)/nconf.o $(obj)/nconf.gui.o: | $(obj)/nconf-cflags
168
169# mconf: Used for the menuconfig target based on lxdialog
170hostprogs += mconf
171lxdialog := $(addprefix lxdialog/, \
172 checklist.o inputbox.o menubox.o textbox.o util.o yesno.o)
173mconf-objs := mconf.o $(lxdialog) $(common-objs)
174
175HOSTLDLIBS_mconf = $(call read-file, $(obj)/mconf-libs)
176$(foreach f, mconf.o $(lxdialog), \
177 $(eval HOSTCFLAGS_$f = $$(call read-file, $(obj)/mconf-cflags)))
178
179$(obj)/mconf: | $(obj)/mconf-libs
180$(addprefix $(obj)/, mconf.o $(lxdialog)): | $(obj)/mconf-cflags
181
182# qconf: Used for the xconfig target based on Qt
183hostprogs += qconf
184qconf-cxxobjs := qconf.o qconf-moc.o
185qconf-objs := images.o $(common-objs)
186
187HOSTLDLIBS_qconf = $(call read-file, $(obj)/qconf-libs)
188HOSTCXXFLAGS_qconf.o = -std=c++11 -fPIC $(call read-file, $(obj)/qconf-cflags)
189HOSTCXXFLAGS_qconf-moc.o = -std=c++11 -fPIC $(call read-file, $(obj)/qconf-cflags)
190$(obj)/qconf: | $(obj)/qconf-libs
191$(obj)/qconf.o $(obj)/qconf-moc.o: | $(obj)/qconf-cflags
192
193quiet_cmd_moc = MOC $@
194 cmd_moc = $(call read-file, $(obj)/qconf-bin)/moc $< -o $@
195
196$(obj)/qconf-moc.cc: $(src)/qconf.h FORCE | $(obj)/qconf-bin
197 $(call if_changed,moc)
198
199targets += qconf-moc.cc
200
201# gconf: Used for the gconfig target based on GTK+
202hostprogs += gconf
203gconf-objs := gconf.o images.o $(common-objs)
204
205HOSTLDLIBS_gconf = $(call read-file, $(obj)/gconf-libs)
206HOSTCFLAGS_gconf.o = $(call read-file, $(obj)/gconf-cflags)
207
208$(obj)/gconf: | $(obj)/gconf-libs
209$(obj)/gconf.o: | $(obj)/gconf-cflags
210
211# check if necessary packages are available, and configure build flags
212cmd_conf_cfg = $< $(addprefix $(obj)/$*conf-, cflags libs bin); touch $(obj)/$*conf-bin
213
214$(obj)/%conf-cflags $(obj)/%conf-libs $(obj)/%conf-bin: $(src)/%conf-cfg.sh
215 $(call cmd,conf_cfg)
216
217clean-files += *conf-cflags *conf-libs *conf-bin